# IntervalSets.jl
Interval Sets for Julia

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/IntervalSets.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaMath.github.io/IntervalSets.jl/dev)
[![Build Status](https://github.com/JuliaMath/IntervalSets.jl/workflows/CI/badge.svg)](https://github.com/JuliaMath/IntervalSets.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaMath/IntervalSets.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaMath/IntervalSets.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

## Quick start

```julia
julia> using IntervalSets

julia> i1 = 1.0 .. 3.0
1.0 .. 3.0

julia> i2 = OpenInterval(0..4)
0 .. 4 (open)

julia> i1 ⊆ i2
true

julia> i2 ⊆ i1
false
```

Please refer to the [documentation](https://JuliaMath.github.io/IntervalSets.jl/stable) for comprehensive guides and examples.

using IntervalSets
using Test
using Dates
using Statistics
import Statistics: mean
using Random
using Unitful
using Plots

import IntervalSets: Domain, endpoints, closedendpoints, TypedEndpointsInterval

using Aqua
Aqua.test_all(IntervalSets)

struct MyClosedUnitInterval <: TypedEndpointsInterval{:closed,:closed,Int} end
endpoints(::MyClosedUnitInterval) = (0,1)
Base.promote_rule(::Type{MyClosedUnitInterval}, ::Type{ClosedInterval{T}}) where T =
        ClosedInterval{T}

struct MyUnitInterval <: AbstractInterval{Int}
    isleftclosed::Bool
    isrightclosed::Bool
end
endpoints(::MyUnitInterval) = (0,1)
closedendpoints(I::MyUnitInterval) = (I.isleftclosed,I.isrightclosed)

struct IncompleteInterval <: AbstractInterval{Int} end

@testset "IntervalSets" begin

    @testset "ordered" begin
        @test ordered(2, 1) == (1, 2)
        @test ordered(1, 2) == (1, 2)
        @test ordered(Float16(1), 2) == (1, 2)
    end

    @testset "iv_str macro" begin
        @test iv"[1,2]" === 1..2
        @test iv"[1,2)" === Interval{:closed, :open}(1, 2)
        @test iv"(1,2]" === Interval{:open, :closed}(1, 2)
        @test iv"(1,2)" === OpenInterval(1, 2)

        for (a,b) in ((1,2), (1.4,3.9), (ℯ,π))
            @test iv"[a,b]" === a..b
            @test iv"[a,b)" === Interval{:closed, :open}(a, b)
            @test iv"(a,b]" === Interval{:open, :closed}(a, b)
            @test iv"(a,b)" === OpenInterval(a, b)
        end

        @test_throws Exception iv"[(1,2)]"
        @test_throws Exception iv"[1,2,]"
        @test_throws Exception iv"[(1,2]"
        @test_throws Exception iv"[(1,,2]"
        @test_throws Exception iv"[1..2]"
        @test_throws Exception iv"(1..2)"
        @test_throws Exception iv"[1...2]"
        @test_throws Exception iv"(1...2)"
        @test_throws Exception iv"1..2"
    end

    @testset "Basic Closed Sets" begin
        @test_throws ErrorException :a .. "b"
        @test_throws ErrorException 1 .. missing
        @test_throws ErrorException 1u"m" .. 2u"s"
        I = 0..3
        @test I === ClosedInterval(0,3)
        @test I === ClosedInterval{Int}(0,3)
        @test I === Interval(0,3)
        @test string(I) == "0 .. 3"
        @test @inferred(UnitRange(I)) === 0:3
        @test @inferred(range(I)) === 0:3
        @test @inferred(UnitRange{Int16}(I)) === Int16(0):Int16(3)
        @test @inferred(ClosedInterval(0:3)) === I
        @test @inferred(ClosedInterval{Float64}(0:3)) === 0.0..3.0
        @test @inferred(ClosedInterval(Base.OneTo(3))) === 1..3
        J = 3..2
        K = 5..4
        L = 3 ± 2
        M = @inferred(ClosedInterval(2, 5.0))
        @test string(M) == "2.0 .. 5.0"
        N = @inferred(ClosedInterval(UInt8(255), 300))

        x, y = CartesianIndex(1, 2, 3, 4), CartesianIndex(1, 2, 3, 4)
        O = @inferred x±y
        @test O == ClosedInterval(x-y, x+y)

        @test eltype(I) == Int
        @test eltype(M) == Float64

        @test !isempty(I)
        @test isempty(J)
        @test J == K
        @test I != K
        @test I == I
        @test J == J
        @test L == L
        @test isequal(I, I)
        @test isequal(J, K)

        @test typeof(leftendpoint(M)) == typeof(rightendpoint(M)) && typeof(leftendpoint(M)) == Float64
        @test typeof(leftendpoint(N)) == typeof(rightendpoint(N)) && typeof(leftendpoint(N)) == Int
        @test @inferred(endpoints(M)) === (2.0,5.0)
        @test @inferred(endpoints(N)) === (255,300)

        @test maximum(I) === 3
        @test minimum(I) === 0
        @test extrema(I) === (0, 3)

        @test 2 in I
        @test issubset(1..2, 0.5..2.5)

        @test @inferred(I ∪ L) == ClosedInterval(0, 5)
        @test @inferred(I ∩ L) == ClosedInterval(1, 3)
        @test isempty(J ∩ K)
        @test isempty((2..5) ∩ (7..10))
        @test isempty((1..10) ∩ (7..2))
        A = Float16(1.1)..Float16(1.234)
        B = Float16(1.235)..Float16(1.3)
        C = Float16(1.236)..Float16(1.3)
        D = Float16(1.1)..Float16(1.236)
        @test D ∪ B == Float16(1.1)..Float16(1.3)
        @test D ∪ C == Float16(1.1)..Float16(1.3)
        @test_throws(ArgumentError, A ∪ C)

        @test 1.5 ∉ 0..1
        @test 1.5 ∉ 2..3
        # Throw error if the union is not an interval.
        @test_throws ArgumentError (0..1) ∪ (2..3)
        # Even though A and B contain all Float16s between their extrema,
        # union should not defined because there exists a Float64 inbetween.
        @test_throws ArgumentError A ∪ B
        x32 = nextfloat(rightendpoint(A))
        x64 = nextfloat(Float64(rightendpoint(A)))
        @test x32 ∉ A
        @test x32 ∈ B
        @test x64 ∉ A
        @test x64 ∉ B

        @test J ⊆ L
        @test (L ⊆ J) == false
        @test K ⊆ I
        @test ClosedInterval(1, 2) ⊆ I
        @test I ⊆ I
        @test (ClosedInterval(7, 9) ⊆ I) == false
        @test I ⊇ I
        @test I ⊇ ClosedInterval(1, 2)
        @test !(I ⊊ I)
        @test !(I ⊋ I)
        @test !(I ⊊ J)
        @test !(J ⊋ I)
        @test J ⊊ I
        @test I ⊋ J

        @test hash(1..3) == hash(1.0..3.0)

        @test width(I) == 3
        @test width(J) == 0

        @test width(ClosedInterval(3,7)) ≡ 4
        @test width(ClosedInterval(4.0,8.0)) ≡ 4.0

        @test mean(0..1) == 0.5

        @test promote(1..2, 1.0..2.0) === (1.0..2.0, 1.0..2.0)
    end

    @testset "Convert" begin
        I = 0..3
        @test 0.0..3.0 === @inferred(convert(ClosedInterval{Float64}, I))
        @test 0.0..3.0 === @inferred(convert(AbstractInterval{Float64}, I))
        @test 0.0..3.0 === @inferred(convert(Domain{Float64}, I))
        @test 0.0..3.0 === @inferred(ClosedInterval{Float64}(I))
        @test 0.0..3.0 === @inferred(convert(TypedEndpointsInterval{:closed,:closed,Float64},I))
        @test I === @inferred(convert(ClosedInterval, I))
        @test I === @inferred(convert(Interval, I))
        @test I === @inferred(ClosedInterval(I))
        @test I === @inferred(Interval(I))
        @test I === @inferred(convert(AbstractInterval, I))
        @test I === @inferred(convert(Domain, I))
        @test I === @inferred(convert(TypedEndpointsInterval{:closed,:closed}, I))
        @test I === @inferred(convert(TypedEndpointsInterval{:closed,:closed,Int}, I))
        @test I === @inferred(convert(ClosedInterval{Int}, I))
        @test_throws InexactError convert(OpenInterval, I)
        @test_throws InexactError convert(Interval{:open,:closed}, I)
        @test_throws InexactError convert(Interval{:closed,:open}, I)
        @test !(convert(ClosedInterval{Float64}, I) === 0..3)
        @test ClosedInterval{Float64}(1,3) === 1.0..3.0
        @test ClosedInterval(0.5..2.5) === 0.5..2.5
        @test ClosedInterval{Int}(1.0..3.0) === 1..3

        J = OpenInterval(I)
        @test_throws InexactError convert(ClosedInterval, J)
        @test iv"(0.,3.)" === @inferred(convert(OpenInterval{Float64}, J))
        @test iv"(0.,3.)" === @inferred(convert(AbstractInterval{Float64}, J))
        @test iv"(0.,3.)" === @inferred(convert(Domain{Float64}, J))
        @test iv"(0.,3.)" === @inferred(OpenInterval{Float64}(J))
        @test OpenInterval(J) === @inferred(convert(OpenInterval, J))
        @test OpenInterval(J) === @inferred(convert(Interval, J))
        @test OpenInterval(J) === @inferred(convert(AbstractInterval, J))
        @test OpenInterval(J) === @inferred(convert(Domain, J))
        @test OpenInterval(J) === @inferred(OpenInterval(J))
        @test OpenInterval(J) === @inferred(OpenInterval{Int}(J))
        @test OpenInterval(J) === @inferred(convert(OpenInterval{Int},J))

        J = Interval{:open,:closed}(I)
        @test_throws InexactError convert(Interval{:closed,:open}, J)
        @test iv"(0.,3.]" === @inferred(convert(Interval{:open,:closed,Float64}, J))
        @test iv"(0.,3.]" === @inferred(convert(AbstractInterval{Float64}, J))
        @test iv"(0.,3.]" === @inferred(convert(Domain{Float64}, J))
        @test iv"(0.,3.]" === @inferred(Interval{:open,:closed,Float64}(J))
        @test Interval{:open,:closed}(J) === @inferred(convert(Interval{:open,:closed}, J))
        @test Interval{:open,:closed}(J) === @inferred(convert(Interval, J))
        @test Interval{:open,:closed}(J) === @inferred(convert(AbstractInterval, J))
        @test Interval{:open,:closed}(J) === @inferred(convert(Domain, J))
        @test Interval{:open,:closed}(J) === @inferred(Interval{:open,:closed}(J))

        J = Interval{:closed,:open}(I)
        @test_throws InexactError convert(Interval{:open,:closed}, J)
        @test iv"[0.,3.)" === @inferred(convert(Interval{:closed,:open,Float64}, J))
        @test iv"[0.,3.)" === @inferred(convert(AbstractInterval{Float64}, J))
        @test iv"[0.,3.)" === @inferred(convert(Domain{Float64}, J))
        @test iv"[0.,3.)" === @inferred(Interval{:closed,:open,Float64}(J))
        @test Interval{:closed,:open}(J) === @inferred(convert(Interval{:closed,:open}, J))
        @test Interval{:closed,:open}(J) === @inferred(convert(Interval, J))
        @test Interval{:closed,:open}(J) === @inferred(convert(AbstractInterval, J))
        @test Interval{:closed,:open}(J) === @inferred(convert(Domain, J))
        @test Interval{:closed,:open}(J) === @inferred(Interval{:closed,:open}(J))

        @test 1.0..2.0 === 1.0..2 === 1..2.0 === ClosedInterval{Float64}(1..2) === Interval(1.0,2.0)
        @test promote_type(Interval{:closed,:open,Float64}, Interval{:closed,:open,Int}) === Interval{:closed,:open,Float64}
    end

    @testset "Interval tests" begin
        for T in (Float32,Float64,BigFloat)
            d = zero(T) .. one(T)
            @test T(0.5) ∈ d
            @test T(1.1) ∉ d
            @test 0.5f0 ∈ d
            @test 1.1f0 ∉ d
            @test BigFloat(0.5) ∈ d
            @test BigFloat(1.1) ∉ d
            @test leftendpoint(d) ∈ d
            @test BigFloat(leftendpoint(d)) ∈ d
            @test nextfloat(leftendpoint(d)) ∈ d
            @test nextfloat(BigFloat(leftendpoint(d))) ∈ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test rightendpoint(d) ∈ d
            @test BigFloat(rightendpoint(d)) ∈ d
            @test nextfloat(rightendpoint(d)) ∉ d
            @test nextfloat(BigFloat(rightendpoint(d))) ∉ d
            @test prevfloat(rightendpoint(d)) ∈ d
            @test prevfloat(rightendpoint(d)) ∈ d

            @test leftendpoint(d) == zero(T)
            @test rightendpoint(d) == one(T)
            @test minimum(d) == infimum(d) == leftendpoint(d)
            @test maximum(d) == supremum(d) == rightendpoint(d)

            @test IntervalSets.isclosedset(d)
            @test !IntervalSets.isopenset(d)
            @test IntervalSets.isleftclosed(d)
            @test !IntervalSets.isleftopen(d)
            @test !IntervalSets.isrightopen(d)
            @test IntervalSets.isrightclosed(d)

            @test convert(AbstractInterval, d) ≡ d
            @test convert(AbstractInterval{T}, d) ≡ d
            @test convert(IntervalSets.Domain, d) ≡ d
            @test convert(IntervalSets.Domain{T}, d) ≡ d

            d = OpenInterval(zero(T) .. one(T))
            @test IntervalSets.isopenset(d)
            @test !IntervalSets.isclosedset(d)
            @test IntervalSets.isopenset(d)
            @test !IntervalSets.isclosedset(d)
            @test !IntervalSets.isleftclosed(d)
            @test IntervalSets.isleftopen(d)
            @test IntervalSets.isrightopen(d)
            @test !IntervalSets.isrightclosed(d)
            @test leftendpoint(d) ∉ d
            @test BigFloat(leftendpoint(d)) ∉ d
            @test nextfloat(leftendpoint(d)) ∈ d
            @test nextfloat(BigFloat(leftendpoint(d))) ∈ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test rightendpoint(d) ∉ d
            @test BigFloat(rightendpoint(d)) ∉ d
            @test nextfloat(rightendpoint(d)) ∉ d
            @test nextfloat(BigFloat(rightendpoint(d))) ∉ d
            @test prevfloat(rightendpoint(d)) ∈ d
            @test prevfloat(rightendpoint(d)) ∈ d
            @test infimum(d) == leftendpoint(d)
            @test supremum(d) == rightendpoint(d)
            @test_throws ArgumentError minimum(d)
            @test_throws ArgumentError maximum(d)

            @test isempty(OpenInterval(1,1))

            d = Interval{:open,:closed}(zero(T) .. one(T))
            @test !IntervalSets.isopenset(d)
            @test !IntervalSets.isclosedset(d)
            @test !IntervalSets.isleftclosed(d)
            @test IntervalSets.isleftopen(d)
            @test !IntervalSets.isrightopen(d)
            @test IntervalSets.isrightclosed(d)
            @test leftendpoint(d) ∉ d
            @test BigFloat(leftendpoint(d)) ∉ d
            @test nextfloat(leftendpoint(d)) ∈ d
            @test nextfloat(BigFloat(leftendpoint(d))) ∈ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test prevfloat(BigFloat(leftendpoint(d))) ∉ d
            @test rightendpoint(d) ∈ d
            @test BigFloat(rightendpoint(d)) ∈ d
            @test nextfloat(rightendpoint(d)) ∉ d
            @test nextfloat(BigFloat(rightendpoint(d))) ∉ d
            @test prevfloat(rightendpoint(d)) ∈ d
            @test prevfloat(BigFloat(rightendpoint(d))) ∈ d
            @test infimum(d) == leftendpoint(d)
            @test maximum(d) == supremum(d) == rightendpoint(d)
            @test_throws ArgumentError minimum(d)

            d = Interval{:closed,:open}(zero(T) .. one(T))
            @test !IntervalSets.isopenset(d)
            @test !IntervalSets.isclosedset(d)
            @test IntervalSets.isleftclosed(d)
            @test !IntervalSets.isleftopen(d)
            @test IntervalSets.isrightopen(d)
            @test !IntervalSets.isrightclosed(d)
            @test leftendpoint(d) ∈ d
            @test BigFloat(leftendpoint(d)) ∈ d
            @test nextfloat(leftendpoint(d)) ∈ d
            @test nextfloat(BigFloat(leftendpoint(d))) ∈ d
            @test prevfloat(leftendpoint(d)) ∉ d
            @test prevfloat(BigFloat(leftendpoint(d))) ∉ d
            @test rightendpoint(d) ∉ d
            @test BigFloat(rightendpoint(d)) ∉ d
            @test nextfloat(rightendpoint(d)) ∉ d
            @test nextfloat(BigFloat(rightendpoint(d))) ∉ d
            @test prevfloat(rightendpoint(d)) ∈ d
            @test prevfloat(BigFloat(rightendpoint(d))) ∈ d
            @test infimum(d) == minimum(d) == leftendpoint(d)
            @test supremum(d) == rightendpoint(d)
            @test_throws ArgumentError maximum(d)


            # - empty interval
            @test isempty(one(T) .. zero(T))
            @test zero(T) ∉ one(T) .. zero(T)

            d = one(T) .. zero(T)
            @test_throws ArgumentError minimum(d)
            @test_throws ArgumentError maximum(d)
            @test_throws ArgumentError infimum(d)
            @test_throws ArgumentError supremum(d)
        end
    end

    @testset "Custom intervals" begin
        I = MyUnitInterval(true,true)
        @test eltype(I) == eltype(typeof(I)) == Int
        @test leftendpoint(I) == 0
        @test rightendpoint(I) == 1
        @test isleftclosed(I)
        @test !isleftopen(I)
        @test isrightclosed(I)
        @test !isrightopen(I)
        @test 0..1 === ClosedInterval(I)
        @test 0..1 === convert(ClosedInterval, I)
        @test 0..1 === ClosedInterval{Int}(I)
        @test 0..1 === convert(ClosedInterval{Int}, I)
        @test 0..1 === convert(Interval, I)
        @test 0..1 === Interval(I)
        @test_throws InexactError convert(OpenInterval, I)

        I = MyUnitInterval(false,false)
        @test leftendpoint(I) == 0
        @test rightendpoint(I) == 1
        @test !isleftclosed(I)
        @test !isrightclosed(I)
        @test iv"(0,1)" === OpenInterval(I)
        @test iv"(0,1)" === convert(OpenInterval, I)
        @test iv"(0,1)" === OpenInterval{Int}(I)
        @test iv"(0,1)" === convert(OpenInterval{Int}, I)
        @test iv"(0,1)" === convert(Interval, I)

        I = MyUnitInterval(false,true)
        @test leftendpoint(I) == 0
        @test rightendpoint(I) == 1
        @test isleftclosed(I) == false
        @test isrightclosed(I) == true
        @test iv"(0,1]" === Interval{:open,:closed}(I)
        @test iv"(0,1]" === convert(Interval{:open,:closed}, I)
        @test iv"(0,1]" === Interval{:open,:closed,Int}(I)
        @test iv"(0,1]" === convert(Interval{:open,:closed,Int}, I)
        @test iv"(0,1]" === convert(Interval, I)
        @test iv"(0,1]" === Interval(I)

        I = MyUnitInterval(true,false)
        @test leftendpoint(I) == 0
        @test rightendpoint(I) == 1
        @test isleftclosed(I) == true
        @test isrightclosed(I) == false
        @test iv"[0,1)" === Interval{:closed,:open}(I)
        @test iv"[0,1)" === convert(Interval{:closed,:open}, I)
        @test iv"[0,1)" === Interval{:closed,:open,Int}(I)
        @test iv"[0,1)" === convert(Interval{:closed,:open,Int}, I)
        @test iv"[0,1)" === convert(Interval, I)
        @test iv"[0,1)" === Interval(I)
        @test convert(AbstractInterval, I) === convert(AbstractInterval{Int}, I) === I
    end

    @testset "Custom typed endpoints interval" begin
        I = MyClosedUnitInterval()
        @test leftendpoint(I) == 0
        @test rightendpoint(I) == 1
        @test isleftclosed(I) == true
        @test isrightclosed(I) == true
        @test ClosedInterval(I) === convert(ClosedInterval, I) ===
                ClosedInterval{Int}(I) === convert(ClosedInterval{Int}, I)  ===
                convert(Interval, I) === Interval(I) === 0..1
        @test_throws InexactError convert(OpenInterval, I)
        @test I ∩ I === 0..1
        @test I ∩ (0.0..0.5) === 0.0..0.5
    end

    @testset "closedendpoints" begin
        @test closedendpoints(0..1) == closedendpoints(MyClosedUnitInterval()) == (true,true)
        @test closedendpoints(Interval{:open,:closed}(0,1)) == (false,true)
        @test closedendpoints(Interval{:closed,:open}(0,1)) == (true,false)
        @test closedendpoints(OpenInterval(0,1)) == (false,false)
    end

    @testset "IteratorSize" begin
        @test Base.IteratorSize(ClosedInterval) == Base.SizeUnknown()
    end

    @testset "IncompleteInterval" begin
        I = IncompleteInterval()
        @test eltype(I) === Int
        @test_throws ErrorException endpoints(I)
        @test_throws ErrorException closedendpoints(I)
        @test_throws MethodError 2 in I
    end

    include("base_methods.jl")
    include("setoperations.jl")
    include("findall.jl")
    include("nonreal_interval.jl")
    include("plots.jl")
end

"""
An `Interval{L,R}(left, right)` where L,R are :open or :closed
is an interval set containg `x` such that
1. `left ≤ x ≤ right` if `L == R == :closed`
2. `left < x ≤ right` if `L == :open` and `R == :closed`
3. `left ≤ x < right` if `L == :closed` and `R == :open`, or
4. `left < x < right` if `L == R == :open`
"""
struct Interval{L,R,T}  <: TypedEndpointsInterval{L,R,T}
    left::T
    right::T

    Interval{L,R,T}(l, r) where {L,R,T} = ((a, b) = checked_conversion(T, l, r); new{L,R,T}(a, b))
end


"""
A `ClosedInterval(left, right)` is an interval set that includes both its upper and lower bounds. In
mathematical notation, the constructed range is `[left, right]`.
"""
const ClosedInterval{T} = Interval{:closed,:closed,T}

"""
An `TypedEndpointsInterval{:open,:open}(left, right)` is an interval set that includes both its upper and lower bounds. In
mathematical notation, the constructed range is `(left, right)`.
"""
const OpenInterval{T} = Interval{:open,:open,T}

Interval{L,R,T}(i::AbstractInterval) where {L,R,T} = Interval{L,R,T}(endpoints(i)...)
Interval{L,R}(left, right) where {L,R} = Interval{L,R}(promote(left,right)...)
Interval{L,R}(left::T, right::T) where {L,R,T} = Interval{L,R,T}(left, right)
Interval(left, right) = ClosedInterval(left, right)


# Interval(::AbstractInterval) allows open/closed intervals to be changed
Interval{L,R}(i::AbstractInterval) where {L,R} = Interval{L,R}(endpoints(i)...)
Interval(i::AbstractInterval) = Interval{isleftclosed(i) ? (:closed) : (:open),
                                         isrightclosed(i) ? (:closed) : (:open)}(i)
Interval(i::TypedEndpointsInterval{L,R}) where {L,R} = Interval{L,R}(i)

"""
    @iv_str -> Interval

Construct an interval with mathematical notation such as `iv"(1,2]"`.

# Examples
```jldoctest
julia> iv"[1,2]"
1 .. 2

julia> iv"[1,2)"
1 .. 2 (closed-open)

julia> iv"(1,2]"
1 .. 2 (open-closed)

julia> iv"(1,2)"
1 .. 2 (open)
```
"""
macro iv_str(s)
    msg = "Invalid expresson `$s`"
    for (reg, f) ∈ (
        (r"^\[(.*)\)$", Interval{:closed, :open}),
        (r"^\((.*)\)$", Interval{:open, :open}),
        (r"^\((.*)\]$", Interval{:open, :closed}),
        (r"^\[(.*)\]$", Interval{:closed, :closed}),
    )
        m = match(reg, s)
        if !isnothing(m)
            try
                args = Meta.parse("("*m.captures[1]*",)")
                if args.head === :incomplete
                    return :(throw(ErrorException("$($msg)")))
                elseif length(args.args) ≠ 2
                    return :(throw(ErrorException("$($msg)")))
                else
                    return :($f($(esc(args))...))
                end
            catch
                return :(throw(ErrorException("$($msg)")))
            end
        end
    end
    return :(throw(ErrorException("$($msg)")))
end

endpoints(i::Interval) = (i.left, i.right)

for L in (:(:open),:(:closed)), R in (:(:open),:(:closed))
    @eval begin
        convert(::Type{Interval{$L,$R}}, i::Interval{$L,$R}) = i
        convert(::Type{Interval{$L,$R,T}}, i::Interval{$L,$R,T}) where T = i
    end
end
convert(::Type{Interval}, i::Interval) = i

function convert(::Type{II}, i::AbstractInterval) where II<:ClosedInterval
    isclosedset(i) ||  throw(InexactError(:convert,II,i))
    II(i)
end
function convert(::Type{II}, i::AbstractInterval) where II<:OpenInterval
    isopenset(i) ||  throw(InexactError(:convert,II,i))
    II(i)
end
function convert(::Type{II}, i::AbstractInterval) where II<:Interval{:open,:closed}
    (isleftopen(i) && isrightclosed(i)) ||  throw(InexactError(:convert,II,i))
    II(i)
end
function convert(::Type{II}, i::AbstractInterval) where II<:Interval{:closed,:open}
    (isleftclosed(i) && isrightopen(i)) ||  throw(InexactError(:convert,II,i))
    II(i)
end

convert(::Type{Interval}, i::AbstractInterval) = Interval(i)

convert(::Type{Domain{T}}, d::Interval{L,R}) where {L,R,T} = convert(Interval{L,R,T}, d)
convert(::Type{AbstractInterval{T}}, d::Interval{L,R}) where {L,R,T} = convert(Interval{L,R,T}, d)
convert(::Type{AbstractInterval{T}}, d::Interval{L,R,T}) where {L,R,T} = convert(Interval{L,R,T}, d)
convert(::Type{TypedEndpointsInterval{L,R,T}}, d::Interval{L,R}) where {L,R,T} = convert(Interval{L,R,T}, d)
convert(::Type{TypedEndpointsInterval{L,R,T}}, d::Interval{L,R,T}) where {L,R,T} = convert(Interval{L,R,T}, d)
convert(::Type{Domain}, d::Interval{L,R}) where {L,R} = d
convert(::Type{AbstractInterval}, d::Interval{L,R}) where {L,R} = d
convert(::Type{TypedEndpointsInterval{L,R}}, d::Interval{L,R}) where {L,R} = d


"""
    iv = l..r

Construct a ClosedInterval `iv` spanning the region from `l` to `r`.

# Examples
```jldoctest
julia> 1..2
1 .. 2

julia> 3..1  # Empty interval set can be defined
3 .. 1
```
"""
..(x, y) = ClosedInterval(x, y)


"""
    iv = center ± halfwidth

Construct a ClosedInterval `iv` spanning the region from
`center - halfwidth` to `center + halfwidth`.

# Examples
```jldoctest
julia> 3 ± 2
1 .. 5
```
"""
±(x, y) = ClosedInterval(x - y, x + y)
±(x::CartesianIndex, y::CartesianIndex) = ClosedInterval(x-y, x+y)

show(io::IO, I::ClosedInterval) = print(io, leftendpoint(I), " .. ", rightendpoint(I))
show(io::IO, I::OpenInterval) = print(io, leftendpoint(I), " .. ", rightendpoint(I), " (open)")
show(io::IO, I::Interval{:open,:closed}) = print(io, leftendpoint(I), " .. ", rightendpoint(I), " (open-closed)")
show(io::IO, I::Interval{:closed,:open}) = print(io, leftendpoint(I), " .. ", rightendpoint(I), " (closed-open)")

# The following are not typestable for mixed endpoint types
_left_intersect_type(::Type{Val{:open}}, ::Type{Val{L2}}, a1, a2) where L2 = a1 < a2 ? (a2,L2) : (a1,:open)
_left_intersect_type(::Type{Val{:closed}}, ::Type{Val{L2}}, a1, a2) where L2 = a1 ≤ a2 ? (a2,L2) : (a1,:closed)
_right_intersect_type(::Type{Val{:open}}, ::Type{Val{R2}}, b1, b2) where R2 = b1 > b2 ? (b2,R2) : (b1,:open)
_right_intersect_type(::Type{Val{:closed}}, ::Type{Val{R2}}, b1, b2) where R2 = b1 ≥ b2 ? (b2,R2) : (b1,:closed)

function intersect(d1::TypedEndpointsInterval{L1,R1}, d2::TypedEndpointsInterval{L2,R2}) where {L1,R1,L2,R2}
    a1, b1 = endpoints(d1); a2, b2 = endpoints(d2)
    a,L = _left_intersect_type(Val{L1}, Val{L2}, a1, a2)
    b,R = _right_intersect_type(Val{R1}, Val{R2}, b1, b2)
    Interval{L,R}(a,b)
end

function intersect(d1::TypedEndpointsInterval{L,R}, d2::TypedEndpointsInterval{L,R}) where {L,R}
    a1, b1 = endpoints(d1); a2, b2 = endpoints(d2)
    Interval{L,R}(max(a1,a2),min(b1,b2))
end

intersect(d1::AbstractInterval, d2::AbstractInterval) = intersect(Interval(d1), Interval(d2))


function union(d1::TypedEndpointsInterval{L1,R1,T1}, d2::TypedEndpointsInterval{L2,R2,T2}) where {L1,R1,T1,L2,R2,T2}
    T = promote_type(T1,T2)
    isempty(d1) && return Interval{L2,R2,T}(d2)
    isempty(d2) && return Interval{L1,R1,T}(d1)
    any(∈(d1), endpoints(d2)) || any(∈(d2), endpoints(d1)) ||
        throw(ArgumentError("Cannot construct union of disjoint sets."))
    _union(d1, d2)
end

# these assume overlap
function _union(A::TypedEndpointsInterval{L,R}, B::TypedEndpointsInterval{L,R}) where {L,R}
    left = min(leftendpoint(A), leftendpoint(B))
    right = max(rightendpoint(A), rightendpoint(B))
    Interval{L,R}(left, right)
end

# this is not typestable
function _union(A::TypedEndpointsInterval{L1,R1}, B::TypedEndpointsInterval{L2,R2}) where {L1,R1,L2,R2}
    if leftendpoint(A) == leftendpoint(B)
        L = L1 == :closed ? :closed : L2
    elseif leftendpoint(A) < leftendpoint(B)
        L = L1
    else
        L = L2
    end
    if rightendpoint(A) == rightendpoint(B)
        R = R1 == :closed ? :closed : R2
    elseif rightendpoint(A) > rightendpoint(B)
        R = R1
    else
        R = R2
    end
    left = min(leftendpoint(A), leftendpoint(B))
    right = max(rightendpoint(A), rightendpoint(B))

    Interval{L,R}(left, right)
end

ClosedInterval{T}(i::AbstractUnitRange{I}) where {T,I<:Integer} = ClosedInterval{T}(minimum(i), maximum(i))
ClosedInterval(i::AbstractUnitRange{I}) where {I<:Integer} = ClosedInterval{I}(minimum(i), maximum(i))

Base.promote_rule(::Type{Interval{L,R,T1}}, ::Type{Interval{L,R,T2}}) where {L,R,T1,T2} = Interval{L,R,promote_type(T1, T2)}

float(i::Interval{L, R, T}) where {L,R,T} = Interval{L, R, float(T)}(endpoints(i)...)

module IntervalSets

using Base: @pure
import Base: eltype, convert, show, in, length, isempty, isequal, isapprox, issubset, ==, hash,
             union, intersect, minimum, maximum, extrema, range, clamp, mod, float, ⊇, ⊊, ⊋,
             UnitRange, LinRange

export AbstractInterval, Interval, OpenInterval, ClosedInterval, @iv_str,
            ⊇, .., ±, ordered, width, leftendpoint, rightendpoint, endpoints,
            isopenset, isclosedset, isleftclosed, isrightclosed,
            isleftopen, isrightopen, closedendpoints,
            infimum, supremum,
            searchsorted_interval

"""
A subtype of `Domain{T}` represents a subset of type `T`, that provides `in`.
"""
abstract type Domain{T} end

Base.IteratorSize(::Type{<:Domain}) = Base.SizeUnknown()
Base.isdisjoint(a::Domain, b::Domain) = isempty(a ∩ b)

"""
A subtype of `AbstractInterval{T}` represents an interval subset of type `T`, that provides
`endpoints`, `closedendpoints`.
"""
abstract type AbstractInterval{T} <: Domain{T} end

"""
    endpoints(d::AI) where AI<:AbstractInterval

A tuple containing the left and right endpoints of the interval.

# Examples
```jldoctest
julia> endpoints(iv"[1,2]")
(1, 2)

julia> endpoints(iv"(2,1)")
(2, 1)
```
"""
endpoints(d::AI) where AI<:AbstractInterval = error("Override endpoints(::$(AI))")

"""
    leftendpoint(d::AbstractInterval)

The left endpoint of the interval.

# Examples
```jldoctest
julia> leftendpoint(iv"[1,2]")
1

julia> leftendpoint(iv"(2,1)")
2
```
"""
leftendpoint(d::AbstractInterval) = endpoints(d)[1]

"""
    rightendpoint(d::AbstractInterval)

The right endpoint of the interval.

# Examples
```jldoctest
julia> rightendpoint(iv"[1,2]")
2

julia> rightendpoint(iv"(2,1)")
1
```
"""
rightendpoint(d::AbstractInterval) = endpoints(d)[2]

"""
    closedendpoints(d::AI) where AI<:AbstractInterval

A tuple of `Bool`'s encoding whether the left/right endpoints are closed.

# Examples
```jldoctest
julia> closedendpoints(iv"[1,2]")
(true, true)

julia> closedendpoints(iv"(1,2]")
(false, true)

julia> closedendpoints(iv"[2,1)")
(true, false)

julia> closedendpoints(iv"(2,1)")
(false, false)
```
"""
closedendpoints(d::AI) where AI<:AbstractInterval = error("Override closedendpoints(::$(AI))")

"""
    isleftclosed(d::AbstractInterval)

Is the interval closed at the left endpoint?

# Examples
```jldoctest
julia> isleftclosed(iv"[1,2]")
true

julia> isleftclosed(iv"(2,1)")
false
```
"""
isleftclosed(d::AbstractInterval) = closedendpoints(d)[1]

"""
    isrightclosed(d::AbstractInterval)

Is the interval closed at the right endpoint?

# Examples
```jldoctest
julia> isrightclosed(iv"[1,2]")
true

julia> isrightclosed(iv"(2,1)")
false
```
"""
isrightclosed(d::AbstractInterval) = closedendpoints(d)[2]

# open_left and open_right are implemented in terms of closed_* above, so those
# are the only ones that should be implemented for specific intervals
"""
    isleftopen(d::AbstractInterval)

Is the interval open at the left endpoint?

# Examples
```jldoctest
julia> isleftopen(iv"[1,2]")
false

julia> isleftopen(iv"(2,1)")
true
```
"""
isleftopen(d::AbstractInterval) = !isleftclosed(d)

"""
    isrightopen(d::AbstractInterval)

Is the interval open at the right endpoint?

# Examples
```jldoctest
julia> isrightopen(iv"[1,2]")
false

julia> isrightopen(iv"(2,1)")
true
```
"""
isrightopen(d::AbstractInterval) = !isrightclosed(d)

"""
    isclosedset(d::AbstractInterval)

Is the interval closed set?

# Examples
```jldoctest
julia> isclosedset(iv"[1,2]")
true

julia> isclosedset(iv"(1,2]")
false

julia> isclosedset(iv"[1,2)")
false

julia> isclosedset(iv"(1,2)")
false
```
"""
isclosedset(d::AbstractInterval) = isleftclosed(d) && isrightclosed(d)

"""
    isopenset(d::AbstractInterval)

Is the interval open set?

# Examples
```jldoctest
julia> isopenset(iv"[1,2]")
false

julia> isopenset(iv"(1,2]")
false

julia> isopenset(iv"[1,2)")
false

julia> isopenset(iv"(1,2)")
true
```
"""
isopenset(d::AbstractInterval) = isleftopen(d) && isrightopen(d)

eltype(::Type{AbstractInterval{T}}) where {T} = T
@pure eltype(::Type{I}) where {I<:AbstractInterval} = eltype(supertype(I))

convert(::Type{AbstractInterval}, i::AbstractInterval) = i
convert(::Type{AbstractInterval{T}}, i::AbstractInterval{T}) where T = i


ordered(a::T, b::T) where {T} = ifelse(a < b, (a, b), (b, a))
ordered(a, b) = ordered(promote(a, b)...)

checked_conversion(::Type{T}, a, b) where {T} = _checked_conversion(T, convert(T, a), convert(T, b))
_checked_conversion(::Type{T}, a::T, b::T) where {T} = a, b
_checked_conversion(::Type{Any}, a, b) = throw(ArgumentError("$a and $b promoted to type Any"))
_checked_conversion(::Type{T}, a, b) where {T} = throw(ArgumentError("$a and $b are not both of type $T"))

function infimum(d::AbstractInterval{T}) where T
    a = leftendpoint(d)
    b = rightendpoint(d)
    a > b && throw(ArgumentError("Infimum not defined for empty intervals"))
    a
end

function supremum(d::AbstractInterval{T}) where T
    a = leftendpoint(d)
    b = rightendpoint(d)
    a > b && throw(ArgumentError("Supremum not defined for empty intervals"))
    b
end

mean(d::AbstractInterval) = (leftendpoint(d) + rightendpoint(d))/2

"""
    w = width(iv)

Calculate the width (max-min) of interval `iv`. Note that for integers
`l` and `r`, `width(l..r) = length(l:r) - 1`.

# Examples
```jldoctest
julia> width(2..7)
5

julia> length(2:7)
6
```
"""
function width(A::AbstractInterval)
    _width = rightendpoint(A) - leftendpoint(A)
    max(zero(_width), _width)   # this works when T is a Date
end

"""
A subtype of `TypedEndpointsInterval{L,R,T}` where `L` and `R` are `:open` or `:closed`,
that represents an interval subset of type `T`, and provides `endpoints`.
"""
abstract type TypedEndpointsInterval{L,R,T} <: AbstractInterval{T} end

closedendpoints(d::TypedEndpointsInterval{:closed,:closed}) = (true,true)
closedendpoints(d::TypedEndpointsInterval{:closed,:open}) = (true,false)
closedendpoints(d::TypedEndpointsInterval{:open,:closed}) = (false,true)
closedendpoints(d::TypedEndpointsInterval{:open,:open}) = (false,false)

# We dispatch to _in to avoid ambiguities if packages define in(v::CustomType, I::TypedEndpointsInterval)
in(v, I::TypedEndpointsInterval) = _in(v, I)
_in(v, I::TypedEndpointsInterval{:closed,:closed}) = leftendpoint(I) ≤ v ≤ rightendpoint(I)
_in(v, I::TypedEndpointsInterval{:open,:open}) = leftendpoint(I) < v < rightendpoint(I)
_in(v, I::TypedEndpointsInterval{:closed,:open}) = leftendpoint(I) ≤ v < rightendpoint(I)
_in(v, I::TypedEndpointsInterval{:open,:closed}) = leftendpoint(I) < v ≤ rightendpoint(I)

_in(v::Complex, I::TypedEndpointsInterval{:closed,:closed}) = isreal(v) && in(real(v), I)
_in(v::Complex, I::TypedEndpointsInterval{:open,:open}) = isreal(v) && in(real(v), I)
_in(v::Complex, I::TypedEndpointsInterval{:closed,:open}) = isreal(v) && in(real(v), I)
_in(v::Complex, I::TypedEndpointsInterval{:open,:closed}) = isreal(v) && in(real(v), I)

_in(::Missing, I::TypedEndpointsInterval{:closed,:closed}) = !isempty(I) && missing
_in(::Missing, I::TypedEndpointsInterval{:open,:open}) = !isempty(I) && missing
_in(::Missing, I::TypedEndpointsInterval{:closed,:open}) = !isempty(I) && missing
_in(::Missing, I::TypedEndpointsInterval{:open,:closed}) = !isempty(I) && missing

isempty(A::TypedEndpointsInterval{:closed,:closed}) = leftendpoint(A) > rightendpoint(A)
isempty(A::TypedEndpointsInterval) = leftendpoint(A) ≥ rightendpoint(A)

isequal(A::TypedEndpointsInterval{L,R}, B::TypedEndpointsInterval{L,R}) where {L,R} = (isequal(leftendpoint(A), leftendpoint(B)) & isequal(rightendpoint(A), rightendpoint(B))) | (isempty(A) & isempty(B))
isequal(A::TypedEndpointsInterval, B::TypedEndpointsInterval) = isempty(A) & isempty(B)

==(A::TypedEndpointsInterval{L,R}, B::TypedEndpointsInterval{L,R}) where {L,R} = (leftendpoint(A) == leftendpoint(B) && rightendpoint(A) == rightendpoint(B)) || (isempty(A) && isempty(B))
==(A::TypedEndpointsInterval, B::TypedEndpointsInterval) = isempty(A) && isempty(B)

function isapprox(A::AbstractInterval, B::AbstractInterval; atol=0, rtol=Base.rtoldefault(eltype(A), eltype(B), atol), kwargs...)
    closedendpoints(A) != closedendpoints(B) && error("Comparing intervals with different closedness is not defined")
    isempty(A) != isempty(B) && return false
    isempty(A) && isempty(B) && return true
    maxabs = max(maximum(abs, endpoints(A)), maximum(abs, endpoints(B)))
    let atol = max(atol, rtol * maxabs)
        isapprox(leftendpoint(A), leftendpoint(B); atol, rtol, kwargs...) && isapprox(rightendpoint(A), rightendpoint(B); atol, rtol, kwargs...)
    end
end

function issubset(A::TypedEndpointsInterval, B::TypedEndpointsInterval)
    Al, Ar = endpoints(A)
    Bl, Br = endpoints(B)
    return isempty(A) | ( (Bl ≤ Al) & (Ar ≤ Br) )
end
function issubset(A::TypedEndpointsInterval{:closed,R1} where R1, B::TypedEndpointsInterval{:open,R2} where R2)
    Al, Ar = endpoints(A)
    Bl, Br = endpoints(B)
    return isempty(A) | ( (Bl < Al) & (Ar ≤ Br) )
end
function issubset(A::TypedEndpointsInterval{L1,:closed} where L1, B::TypedEndpointsInterval{L2,:open} where L2)
    Al, Ar = endpoints(A)
    Bl, Br = endpoints(B)
    return isempty(A) | ( (Bl ≤ Al) & (Ar < Br) )
end
function issubset(A::TypedEndpointsInterval{:closed,:closed}, B::TypedEndpointsInterval{:open,:open})
    Al, Ar = endpoints(A)
    Bl, Br = endpoints(B)
    return isempty(A) | ( (Bl < Al) & (Ar < Br) )
end

⊊(A::AbstractInterval, B::AbstractInterval) = (A ≠ B) & (A ⊆ B)

const _interval_hash = UInt == UInt64 ? 0x1588c274e0a33ad4 : 0x1e3f7252

hash(I::TypedEndpointsInterval, h::UInt) = hash(leftendpoint(I), hash(rightendpoint(I), hash(_interval_hash, h)))

minimum(d::TypedEndpointsInterval{:closed}) = infimum(d)
minimum(d::TypedEndpointsInterval{:open}) = throw(ArgumentError("$d is open on the left. Use infimum."))
maximum(d::TypedEndpointsInterval{L,:closed}) where L = supremum(d)
maximum(d::TypedEndpointsInterval{L,:open}) where L = throw(ArgumentError("$d is open on the right. Use supremum."))

extrema(I::TypedEndpointsInterval) = (infimum(I), supremum(I))

# Open and closed at endpoints
isleftclosed(d::TypedEndpointsInterval{:closed}) = true
isleftclosed(d::TypedEndpointsInterval{:open}) = false
isrightclosed(d::TypedEndpointsInterval{L,:closed}) where {L} = true
isrightclosed(d::TypedEndpointsInterval{L,:open}) where {L} = false

# UnitRange construction
# The third is the one we want, but the first two are needed to resolve ambiguities
Base.Slice{T}(i::TypedEndpointsInterval{:closed,:closed,I}) where {T<:AbstractUnitRange,I<:Integer} =
    Base.Slice{T}(minimum(i):maximum(i))
Base.Slice(i::TypedEndpointsInterval{:closed,:closed,I}) where I<:Integer =
    Base.Slice(minimum(i):maximum(i))
function Base.OneTo{T}(i::TypedEndpointsInterval{:closed,:closed,I}) where {T<:Integer,I<:Integer}
    @noinline throwstart(i) = throw(ArgumentError("smallest element must be 1, got $(minimum(i))"))
    minimum(i) == 1 || throwstart(i)
    Base.OneTo{T}(maximum(i))
end
Base.OneTo(i::TypedEndpointsInterval{:closed,:closed,I}) where {I<:Integer} =
    Base.OneTo{I}(i)
Base.UnitRange{T}(i::TypedEndpointsInterval{:closed,:closed,I}) where {T<:Integer,I<:Integer} = UnitRange{T}(minimum(i), maximum(i))
Base.UnitRange(i::TypedEndpointsInterval{:closed,:closed,I}) where {I<:Integer} = UnitRange{I}(i)
range(i::TypedEndpointsInterval{:closed,:closed,I}) where {I<:Integer} = UnitRange{I}(i)

"""
    range(i::ClosedInterval; step, length)
    range(i::ClosedInterval, length::Integer)

Constructs a range of a specified step or length.

# Examples
```jldoctest
julia> range(1..2, 8)
1.0:0.14285714285714285:2.0

julia> range(1, 2, 8)
1.0:0.14285714285714285:2.0

julia> range(1..2, step=0.2)
1.0:0.2:2.0

julia> range(1, 2, step=0.2)
1.0:0.2:2.0
```
"""
range(i::TypedEndpointsInterval{:closed,:closed}; step=nothing, length=nothing) =
    range(leftendpoint(i); stop=rightendpoint(i), step=step, length=length)
range(i::TypedEndpointsInterval{:closed,:closed}, length::Integer) = range(i; length=length)

"""
    range(i::Interval{:closed,:open}; length)
    range(i::Interval{:closed,:open}, length::Integer)
    range(i::Interval{:open,:closed}; length)
    range(i::Interval{:open,:closed}, length::Integer)

Constructs a range of a specified length with `step=width(i)/length`.

# Examples
```jldoctest
julia> range(iv"[1, 2)", 7)  # Does not contain right endpoint
1.0:0.14285714285714285:1.8571428571428572

julia> range(iv"(1, 2]", 7)  # Does not contain left endpoint
1.1428571428571428:0.14285714285714285:2.0

julia> range(1, 2, 8)
1.0:0.14285714285714285:2.0
```
"""
range(i::TypedEndpointsInterval{:closed,:open}; length::Integer) =
    range(leftendpoint(i); step=width(i)/length, length=length)
range(i::TypedEndpointsInterval{:closed,:open}, length::Integer) = range(i; length=length)

range(i::TypedEndpointsInterval{:open,:closed}; length::Integer) =
    range(; stop = rightendpoint(i), step = width(i)/length, length)
range(i::TypedEndpointsInterval{:open,:closed}, length::Integer) = range(i; length)

"""
    range(i::OpenInterval; length)
    range(i::OpenInterval, length::Integer)

Constructs a range of a specified length with `step = width(i) / (length + 1)`.

# Examples
```jldoctest
julia> range(iv"(1, 4)", 5)  # Does not contain the endpoints
1.5:0.5:3.5

julia> range(1, 4, 7)
1.0:0.5:4.0
```
"""
function range(i::TypedEndpointsInterval{:open,:open}; length::Integer)
    step = width(i) / (length + 1)
    range(leftendpoint(i) + step; step, length)
end

range(i::TypedEndpointsInterval{:open,:open}, length::Integer) = range(i; length)

LinRange(i::TypedEndpointsInterval, length::Integer) = LinRange(range(i, length))

"""
    clamp(t, i::ClosedInterval)

Clamp the scalar `t` such that the result is in the interval `i`.

# Examples
```jldoctest
julia> clamp(1.2, 1..2)
1.2

julia> clamp(2.2, 1..2)
2.0
```
"""
clamp(t, i::TypedEndpointsInterval{:closed,:closed}) =
    clamp(t, leftendpoint(i), rightendpoint(i))

"""
    mod(x, i::AbstractInterval)

Find `y` in the `i` interval such that ``x ≡ y \\pmod w``, where `w = width(i)`.

# Examples

```jldoctest
julia> I = 2.5..4.5;

julia> mod(3.0, I)
3.0

julia> mod(5.0, I)
3.0

julia> mod(2.5, I)
2.5

julia> mod(4.5, I)  # (a in I) does not imply (a == mod(a, I)) for closed intervals
2.5

julia> mod(4.5, Interval{:open, :closed}(2.5, 4.5))
4.5
```
"""
mod(x, i::TypedEndpointsInterval{:closed,:closed}) = mod(x - leftendpoint(i), width(i)) + leftendpoint(i)

function mod(x, i::AbstractInterval)
    res = mod(x - leftendpoint(i), width(i)) + leftendpoint(i)
    if res == rightendpoint(i) && isrightopen(i)
        isleftclosed(i) && return oftype(res, leftendpoint(i))
    elseif res == leftendpoint(i) && isleftopen(i)
        isrightclosed(i) && return oftype(res, rightendpoint(i))
    else
        return res
    end
    throw(DomainError(x, "mod() result is an endpoint of the open interval $i"))
end

include("interval.jl")
include("findall.jl")

if !isdefined(Base, :get_extension)
    include("../ext/IntervalSetsStatisticsExt.jl")
    include("../ext/IntervalSetsRandomExt.jl")
    include("../ext/IntervalSetsRecipesBaseExt.jl")
end

end # module

module IntervalSetsRecipesBaseExt

using IntervalSets
using RecipesBase

@recipe function f(I::AbstractInterval; offset=0.0)
    a, b = Float64.(extrema(I))
    c = get(plotattributes, :background_color, :white)
    w = get(plotattributes, :linewidth, 3)
    r = get(plotattributes, :markersize, 8)
    openpoints = Float64[]
    isleftopen(I) && push!(openpoints, a)
    isrightopen(I) && push!(openpoints, b)
    @series begin
        seriestype := :line
        primary := true
        marker := :circle
        markerstrokewidth := 0
        markersize := r
        linewidth := w
        [a,b], [offset, offset]
    end
    @series begin
        seriestype := :scatter
        primary := false
        markerstrokewidth := 0
        markersize := r-w
        markercolor := c
        openpoints, fill(offset, length(openpoints))
    end
end

end

module IntervalSetsRandomExt

using IntervalSets
using IntervalSets: TypedEndpointsInterval
using Random

# random sampling from interval
Random.gentype(::Type{Interval{L,R,T}}) where {L,R,T} = float(T)
function Random.rand(rng::AbstractRNG, i::Random.SamplerTrivial{<:TypedEndpointsInterval{:closed, :closed, T}}) where T<:Real
    _i = i[]
    isempty(_i) && throw(ArgumentError("The interval should be non-empty."))
    a,b = endpoints(_i)
    t = rand(rng, float(T)) # technically this samples from [0, 1), but we still allow it with TypedEndpointsInterval{:closed, :closed} for convenience
    return clamp(t*a+(1-t)*b, _i)
end

end

@testset "plot" begin
    dir_out = joinpath(@__DIR__, "out_plot")
    rm(dir_out; force=true, recursive=true)
    mkpath(dir_out)

    @testset "TypedEndpointsInterval" begin
        pl = plot(iv"[1,2]"; aspectratio=1)
        plot!(pl, iv"(4,5)"; aspectratio=1)
        plot!(pl, iv"[6,8)"; aspectratio=1)
        plot!(pl, iv"(9,9.2]"; aspectratio=1)

        path_img = joinpath(dir_out, "TypedEndpointsInterval.png")
        @test !isfile(path_img)
        savefig(pl, path_img)
        @test isfile(path_img)
    end

    @testset "Logo" begin
        I₁ = iv"(19.676, 71.327)"
        I₂ = iv"[2.675, 49.676]"
        I₃ = iv"[71.326, 96.326)"
        I₄ = I₁ ∩ I₂
        pl = plot(I₁, offset=-5.00, color=Colors.JULIA_LOGO_COLORS[3], linewidth=30, markersize=60, aspectratio=1)
        plot!(pl, I₂, offset=-25.0, color=Colors.JULIA_LOGO_COLORS[2], linewidth=30, markersize=60)
        plot!(pl, I₃, offset=-37.5, color=Colors.JULIA_LOGO_COLORS[4], linewidth=30, markersize=60)
        plot!(pl, I₄, offset=-50.0, color=Colors.JULIA_LOGO_COLORS[1], linewidth=30, markersize=60)

        path_img = joinpath(dir_out, "Logo.png")
        @test !isfile(path_img)
        savefig(pl, path_img)
        @test isfile(path_img)
    end
end

using OffsetArrays
using Unitful

# Helper function to test that findall(in(interval), x) works. By
# default, a reference is generated using the general algorithm,
# linear in complexity, by generating a vector with the same contents
# as x.
function assert_in_interval(x, interval,
                            expected=findall(v -> v ∈ interval, x))

    result = :(findall(in($interval), $x))
    expr = :($result == $expected || isempty($result) && isempty($expected))
    if !(@eval $expr)
        println("Looking for elements of $x ∈ $interval, got $(@eval $result), expected $expected")
        length(x) < 30 && println("    x = ", collect(pairs(x)), "\n")
    end
    @eval @test $expr
end

@testset "Interval coverage" begin
    @testset "Basic tests" begin
        let x = range(0, stop=1, length=21)
            Random.seed!(321)
            @testset "$kind" for (kind,end_points) in [
                ("Two intervals", [(0.0, 0.5), (0.25,0.5)]),
                ("Three intervals", [(0, 1/3), (1/3, 2/3), (2/3, 1)]),
                ("Random intervals", [minmax(rand(),rand()) for i = 1:2]),
                ("Interval containing one point", [(0.4619303378979984,0.5450937144417902)]),
                ("Interval containing no points", [(0.9072957410215778,0.9082803807133988)])
            ]
                @testset "L=$L" for L=[:closed,:open]
                    @testset "R=$R" for R=[:closed,:open]
                        for (a,b) in end_points
                            interval = Interval{L,R}(a, b)
                            @testset "Reversed: $reversed" for reversed in [false, true]
                                assert_in_interval(reversed ? reverse(x) : x, interval)
                            end
                        end
                    end
                end
            end

            @testset "Open interval" begin
                assert_in_interval(x, OpenInterval(0.2,0.4), 6:8)
            end
        end
    end

    @testset "Partially covered intervals" begin
        @testset "$T" for T in (Float32,Float64,BigFloat)
            @testset "$name, x = $x" for (name,x) in [
                ("Outside left",range(T(-1),stop=T(-0.5),length=10)),
                ("Touching left",range(T(-1),stop=T(0),length=10)),
                ("Touching left-ϵ",range(T(-1),stop=T(0)-eps(T),length=10)),
                ("Touching left+ϵ",range(T(-1),stop=T(0)+eps(T),length=10)),

                ("Outside right",range(T(1.5),stop=T(2),length=10)),
                ("Touching right",range(T(1),stop=T(2),length=10)),
                ("Touching right-ϵ",range(T(1)-eps(T),stop=T(2),length=10)),
                ("Touching right+ϵ",range(T(1)+eps(T),stop=T(2),length=10)),

                ("Other right",range(T(0.5),stop=T(1),length=10)),
                ("Other right-ϵ",range(T(0.5)-eps(T(0.5)),stop=T(1),length=10)),
                ("Other right+ϵ",range(T(0.5)+eps(T(0.5)),stop=T(1),length=10)),

                ("Complete", range(T(0),stop=T(1),length=10)),
                ("Complete-ϵ", range(eps(T),stop=T(1)-eps(T),length=10)),
                ("Complete+ϵ", range(-eps(T),stop=T(1)+eps(T),length=10)),

                ("Left partial", range(T(-0.5),stop=T(0.6),length=10)),
                ("Left", range(T(-0.5),stop=T(1.0),length=10)),
                ("Right partial", range(T(0.5),stop=T(1.6),length=10)),
                ("Right", range(T(0),stop=T(1.6),length=10))]
                @testset "L=$L" for L=[:closed,:open]
                    @testset "R=$R" for R=[:closed,:open]
                        @testset "Reversed: $reversed" for reversed in [false, true]
                            for (a,b) in [(T(0.0),T(0.5)),(T(0.5),T(1.0))]
                                interval = Interval{L,R}(a, b)
                                assert_in_interval(reversed ? reverse(x) : x, interval)
                            end
                        end
                    end
                end
            end
        end
    end

    @testset "Large intervals" begin
        @test findall(in(4..Inf), 2:2:10) == 2:5
        @test findall(in(4..1e20), 2:2:10) == 2:5
        @test isempty(findall(in(-Inf..(-1e20)), 2:2:10))
    end

    @testset "Reverse intervals" begin
        for x in [1:10, 1:3:10, 2:3:11, -1:9, -2:0.5:5]
            for lo in -3:4, hi in 5:13
                for L in [:closed, :open], R in [:closed, :open]
                    interval = Interval{L,R}(lo,hi)
                    assert_in_interval(x, interval)
                    assert_in_interval(reverse(x), interval)
                end
            end
        end
    end

    @testset "Arrays" begin
        @test findall(in(1..6), collect(0:7)) == 2:7
        @test findall(in(1..6), reshape(1:16, 4, 4)) ==
            vcat([CartesianIndex(i,1) for i = 1:4], CartesianIndex(1,2), CartesianIndex(2,2))
    end

    @testset "Empty ranges and intervals" begin
        # Range empty
        @test isempty(findall(in(1..6), 1:0))
        # Interval empty
        @test isempty(findall(in(Interval{:closed,:open}(1.0..1.0)),
                              0.0:0.02040816326530612:1.0))
    end

    @testset "Offset arrays" begin
        for (x,interval) in [(OffsetArray(ones(10), -5), -1..1),
                             (OffsetArray(1:5, -3), 2..4),
                             (OffsetArray(5:-1:1, -5), 2..4)]
            assert_in_interval(x, interval)
            assert_in_interval(reverse(x), interval)
        end
    end

    @testset "Units, dates" begin
        for (x, interval) in [
            [
                ([-2u"m", 3u"m"], -1u"m"..1u"m"),
                ([-2u"m", 0u"m", 1u"m"], -1u"m"..1u"m"),
                (-2u"m":10u"m":50u"m", -1u"m"..1u"m"),
                (-2u"m":1u"m":1u"m", -1u"m"..1u"m"),
                (-2u"km":1u"cm":1u"km", -1u"m"..1u"m"),
                (-2u"km":1u"cm":1u"km", -1u"m"..1u"km"),
                (-2u"km":0.1u"m":1u"km", -1u"m"..1u"km"),
                (-2u"m":0.1u"m":1u"m", -1.05u"m"..1u"km"),
                (-2u"m":0.1u"m":1u"m", -4u"m"..1u"km"),
                (-2u"m":0.1u"m":1u"m", -4.05u"m"..1u"km"),
                (Date(2021, 1, 1):Day(1):Date(2021, 3, 1), Date(2020, 1, 11)..Date(2020, 2, 22)),
                (Date(2021, 1, 1):Day(1):Date(2021, 3, 1), Date(2021, 1, 11)..Date(2021, 2, 22)),
                (DateTime(2021, 1, 1):Millisecond(10000):DateTime(2021, 3, 1), DateTime(2020, 1, 11)..DateTime(2020, 2, 22)),
                (DateTime(2021, 1, 1):Millisecond(10000):DateTime(2021, 3, 1), DateTime(2021, 1, 11)..DateTime(2021, 2, 22)),
            ]
        ]
            assert_in_interval(x, interval)
            assert_in_interval(reverse(x), interval)
        end
    end

    @testset "zero-step ranges" begin
        r = range(1, 1, length=10)
        @test findall(in(1..3),r) == 1:10
        @test findall(in(2..3),r) |> isempty
    end

    @testset "searchsorted" begin
        x = [-10, 0, 1, 1 + eps(), 1.2, 1.5, 1.9, 2 - eps(), 2]
        @test searchsorted_interval(x, -Inf..Inf) == 1:9
        i = Interval{:closed, :closed}(1, 2)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:9
        i = Interval{:open  , :closed}(1, 2)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 4:9
        i = Interval{:closed, :open  }(1, 2)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:8
        i = Interval{:open  , :open  }(1, 2)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 4:8
        i = Interval{:closed, :closed}(1, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:3
        i = Interval{:open  , :closed}(1, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:2
        i = Interval{:closed, :open  }(1, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:2
        i = Interval{:open  , :open  }(1, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 3:2
        i = Interval{:closed, :closed}(2, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 9:8
        i = Interval{:open  , :closed}(2, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 9:8
        i = Interval{:closed, :open  }(2, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 9:8
        i = Interval{:open  , :open  }(2, 1)
        @test searchsorted_interval(x, i) == findall(in(i),x) == 9:8
    end
end

@testset "float" begin
    i1 = 1..2
    @test i1 isa ClosedInterval{Int}
    @test float(i1) isa ClosedInterval{Float64}
    @test float(i1) == i1
    i2 = big(1)..2
    @test i2 isa ClosedInterval{BigInt}
    @test float(i2) isa ClosedInterval{BigFloat}
    @test float(i2) == i2
    i3 = OpenInterval(1,2)
    @test i3 isa OpenInterval{Int}
    @test float(i3) isa OpenInterval{Float64}
    @test float(i3) == i3
    i4 = OpenInterval(1.,2.)
    @test i4 isa OpenInterval{Float64}
    @test float(i4) isa OpenInterval{Float64}
    @test float(i4) == i4
end

@testset "OneTo" begin
    @test_throws ArgumentError Base.OneTo{Int}(0..5)
    @test_throws ArgumentError Base.OneTo(0..5)
    @test Base.OneTo(1..5) == Base.OneTo{Int}(1..5) == Base.OneTo(5)
    @test Base.Slice(1..5) == Base.Slice{UnitRange{Int}}(1..5) == Base.Slice(1:5)
end

@testset "range" begin
    @test range(0..1, 10) == range(0; stop=1, length=10)
    @test range(0..1; length=10) == range(0; stop=1, length=10)
    @test range(0..1; step=1/10) == range(0; stop=1, step=1/10)
    @test range(Interval{:closed,:open}(0..1), 10) == range(0; step=1/10, length=10)
    @test range(Interval{:closed,:open}(0..1); length=10) == range(0; step=1/10, length=10)
    @test range(Interval{:open,:closed}(0..1), 10) == range(; stop=1, step=1/10, length=10)
    @test range(Interval{:open,:closed}(0..1); length=10) == range(1/10; step=1/10, length=10)
    @test range(OpenInterval(0..1), 7) == range(; stop=7/8, step=1/8, length=7)
    @test range(OpenInterval(0..1); length=7) == range(1/8; step=1/8, length=7)
end

@testset "LinRange" begin
    @test @inferred(LinRange(0..1, 10)) === LinRange(0, 1, 10)
    @test LinRange(Interval{:closed,:open}(0..1), 10) === LinRange(range(Interval{:closed,:open}(0..1), 10))
    @test LinRange(Interval{:open,:closed}(0..1), 10) === LinRange(range(Interval{:open,:closed}(0..1), 10))
    @test LinRange(OpenInterval(0..1), 7) === LinRange(range(OpenInterval(0..1), 7))
    @test_throws MethodError LinRange(0..3)
end

@testset "clamp" begin
    @test clamp(1, 0..3) == 1
    @test clamp(1.0, 1.5..3) == 1.5
    @test clamp(1.0, 0..0.5) == 0.5
    @test clamp.([pi, 1.0, big(10.)], Ref(2..9.)) == [big(pi), 2, 9]
end

@testset "mod" begin
    @test mod(10, 0..3) === 1
    @test mod(-10, 0..3) === 2
    @test mod(10.5, 0..3) == 1.5
    @test mod(10.5, 1..1) |> isnan
    @test mod(10.5, Interval{:open, :open}(0, 3)) == 1.5
    @test mod(10.5, Interval{:open, :open}(1, 1)) |> isnan

    @test_throws DomainError mod(0, Interval{:open, :open}(0, 3))
    for x in (0, 3, 0.0, -0.0, 3.0, -eps())
        @test mod(x, Interval{:closed, :open}(0, 3))::typeof(x) == 0
        @test mod(x, Interval{:open, :closed}(0, 3))::typeof(x) == 3
    end
end

@testset "isapprox" begin
    @test 1..2 ≈ 1..2
    @test 1..2 ≈ (1+1e-10)..2
    @test 1..2 ≉ 1..2.01
    @test 10..11 ≈ 10.1..10.9  rtol=0.01
    @test 10..11 ≈ 10.1..10.9  atol=0.1
    @test 10..11 ≉ 10.1..10.9  rtol=0.005
    @test 10..11 ≉ 10.1..10.9  atol=0.05
    @test 0..1 ≈ eps()..1
    @test 100.0..100.0 ≉ nextfloat(100.0)..100.0
    @test 3..1 ≈ 5..1

    # See discussion in https://github.com/JuliaMath/IntervalSets.jl/pull/129
    @test_throws Exception OpenInterval(0, 1) ≈ ClosedInterval(0, 1)
end

@testset "rand" begin
    @test rand(1..2) isa Float64
    @test rand(1..2.) isa Float64
    @test rand(1..big(2)) isa BigFloat
    @test rand(1..(3//2)) isa Float64
    @test rand(Int32(1)..Int32(2)) isa Float64
    @test rand(Float32(1)..Float32(2)) isa Float32
    @test_throws ArgumentError rand(2..1)

    i1 = 1..2
    i2 = 3e100..3e100
    i3 = 1..typemax(Float64)
    i4 = typemin(Float64)..1
    @testset "rand test for $(i)" for i in [i1,i2,i3,i4]
        for _ in 1:100
            @test rand(i1) in i1
            @test rand(i1,10) ⊆ i1
        end
    end

    # If the width is too big, the return value is NaN (sadly).
    i5 = typemin(Float64)..typemax(Float64)
    @test_broken rand(i5) in i5
    @test_broken rand(i5,10) ⊆ i5
    @test_broken !isnan(rand(i5))
    @test_broken !isnan(rand(i5,10))

    # special test to catch issue mentioned at the end of https://github.com/JuliaApproximation/DomainSets.jl/pull/112
    struct RandTestUnitInterval <: TypedEndpointsInterval{:closed, :closed, Float64} end
    IntervalSets.endpoints(::RandTestUnitInterval) = (-1.0, 1.0)
    @test rand(RandTestUnitInterval()) in -1.0..1.0
end

"""
    findall(in(interval), x::AbstractRange)

Return all indices `i` for which `x[i] ∈ interval`, specialized for
the case where `x` is a range, which enables constant-time complexity.

# Examples

```jldoctest
julia> x = range(0,stop=3,length=10)
0.0:0.3333333333333333:3.0

julia> collect(x)'
1×10 adjoint(::Vector{Float64}) with eltype Float64:
 0.0  0.333333  0.666667  1.0  1.33333  1.66667  2.0  2.33333  2.66667  3.0

julia> findall(in(1..6), x)
4:10
```

It also works for decreasing ranges:
```jldoctest
julia> y = 8:-0.5:0
8.0:-0.5:0.0

julia> collect(y)'
1×17 adjoint(::Vector{Float64}) with eltype Float64:
 8.0  7.5  7.0  6.5  6.0  5.5  5.0  4.5  …  3.0  2.5  2.0  1.5  1.0  0.5  0.0

julia> findall(in(1..6), y)
5:15

julia> findall(in(Interval{:open,:closed}(1,6)), y) # (1,6], does not include 1
5:14
```
"""
Base.findall(interval_d::Base.Fix2{typeof(in), <:Interval}, x::AbstractRange) =
    searchsorted_interval(x, interval_d.x; rev=step(x) < zero(step(x)))

# We overload Base._findin to avoid an ambiguity that arises with
# Base.findall(interval_d::Base.Fix2{typeof(in),Interval{L,R,T}}, x::AbstractArray)
function Base._findin(a::Union{AbstractArray, Tuple}, b::Interval)
    ind  = Vector{eltype(keys(a))}()
    @inbounds for (i,ai) in pairs(a)
        ai in b && push!(ind, i)
    end
    ind
end

"""
    searchsorted_interval(a, i::Interval; [rev=false])

Return the range of indices of `a` which is inside of the interval `i` (using binary search), assuming that
`a` is already sorted. Return an empty range located at the insertion point if a does not contain values in `i`.

# Examples
```jldoctest
julia> searchsorted_interval([1,2,3,5], 2..4)
2:3

julia> searchsorted_interval([1,2,3,5], 4..1)
4:3

julia> searchsorted_interval(Float64[], 1..3)
1:0
```
"""
function searchsorted_interval(X, i::Interval{L, R}; rev=false) where {L, R}
    ord = Base.Order.ord(<, identity, rev)
    if rev === true
        _searchsorted_begin(X, rightendpoint(i), Val(R), ord):_searchsorted_end(X, leftendpoint(i), Val(L), ord)
    else
        _searchsorted_begin(X, leftendpoint(i), Val(L), ord):_searchsorted_end(X, rightendpoint(i), Val(R), ord)
    end
end

_searchsorted_begin(X, x, ::Val{:closed}, ord) = searchsortedfirst(X, x, ord)
_searchsorted_begin(X, x,   ::Val{:open}, ord) =  searchsortedlast(X, x, ord) + 1
  _searchsorted_end(X, x, ::Val{:closed}, ord) =  searchsortedlast(X, x, ord)
  _searchsorted_end(X, x,   ::Val{:open}, ord) = searchsortedfirst(X, x, ord) - 1

@testset "Unitful interval" begin
    @test 1.5u"m" in 1u"m" .. 2u"m"
    @test 1500u"μm" in 1u"mm" .. 1u"m"
    @test !(500u"μm" in 1u"mm" .. 1u"m")
    @test 1u"m" .. 2u"m" == 1000u"mm" .. 2000u"mm"
end

@testset "Day interval" begin
    A = Date(1990, 1, 1); B = Date(1990, 3, 1)
    @test width(ClosedInterval(A, B)) == Dates.Day(59)
    @test width(ClosedInterval(B, A)) == Dates.Day(0)
    @test isempty(ClosedInterval(B, A))
end

@testset "Union and intersection with $T" for T in (Float32,Float64)
    # i1      0 ------>------ 1
    # i2         1/3 ->- 1/2
    # i3                 1/2 ------>------ 2
    # i4                                   2 -->-- 3
    # i5                        1.0+ -->-- 2
    # i_empty 0 ------<------ 1
    i1 = zero(T) .. one(T)
    i2 = one(T)/3 .. one(T)/2
    i3 = one(T)/2 .. 2*one(T)
    i4 = T(2) .. T(3)
    i5 = nextfloat(one(T)) .. 2one(T)
    i_empty = one(T) ..zero(T)

    # - union of completely overlapping intervals
    # i1      0 ------>------ 1
    # i2         1/3 ->- 1/2
    @test (@inferred i1 ∪ i2) ≡ (@inferred i2 ∪ i1) ≡ i1
    @test Interval{:open,:closed}(i1) ∪ Interval{:open,:closed}(i2) ≡
            Interval{:open,:closed}(i2) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)
    @test Interval{:closed,:open}(i1) ∪ Interval{:closed,:open}(i2) ≡
            Interval{:closed,:open}(i2) ∪ Interval{:closed,:open}(i1) ≡ Interval{:closed,:open}(i1)
    @test OpenInterval(i1) ∪ OpenInterval(i2) ≡
            OpenInterval(i2) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test i1 ∪ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(i2) ∪ i1 ≡ i1
    @test i1 ∪ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∪ i1 ≡ i1
    @test i1 ∪ OpenInterval(i2) ≡ OpenInterval(i2) ∪ i1 ≡ i1
    @test OpenInterval(i1) ∪ i2 ≡ i2 ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test OpenInterval(i1) ∪ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(i2) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test OpenInterval(i1) ∪ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test Interval{:open,:closed}(i1) ∪ OpenInterval(i2) ≡ OpenInterval(i2) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)
    @test Interval{:open,:closed}(i1) ∪ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)

    # - intersection of completely overlapping intervals
    # i1      0 ------>------ 1
    # i2         1/3 ->- 1/2
    @test (@inferred i1 ∩ i2) ≡ (@inferred i2 ∩ i1) ≡ i2
    @test Interval{:open,:closed}(i1) ∩ Interval{:open,:closed}(i2) ≡
            Interval{:open,:closed}(i2) ∩ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i2)
    @test Interval{:closed,:open}(i1) ∩ Interval{:closed,:open}(i2) ≡
            Interval{:closed,:open}(i2) ∩ Interval{:closed,:open}(i1) ≡ Interval{:closed,:open}(i2)
    @test OpenInterval(i1) ∩ OpenInterval(i2) ≡
            OpenInterval(i2) ∩ OpenInterval(i1) ≡ OpenInterval(i2)
    @test i1 ∩ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(i2) ∩ i1 ≡  Interval{:open,:closed}(i2)
    @test i1 ∩ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∩ i1 ≡ Interval{:closed,:open}(i2)
    @test i1 ∩ OpenInterval(i2) ≡ OpenInterval(i2) ∩ i1 ≡ OpenInterval(i2)
    @test OpenInterval(i1) ∩ i2 ≡ i2 ∩ OpenInterval(i1) ≡ i2
    @test OpenInterval(i1) ∩ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(i2) ∩ OpenInterval(i1) ≡ Interval{:open,:closed}(i2)
    @test OpenInterval(i1) ∩ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∩ OpenInterval(i1) ≡ Interval{:closed,:open}(i2)
    @test Interval{:open,:closed}(i1) ∩ OpenInterval(i2) ≡ OpenInterval(i2) ∩ Interval{:open,:closed}(i1) ≡ OpenInterval(i2)
    @test Interval{:open,:closed}(i1) ∩ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(i2) ∩ Interval{:open,:closed}(i1) ≡ Interval{:closed,:open}(i2)
    @test !isdisjoint(i1, i2)


    # - union of partially overlapping intervals
    # i1      0 ------>------ 1
    # i3                 1/2 ------>------ 2
    d = zero(T) .. 2*one(T)
    @test (@inferred i1 ∪ i3) ≡ (@inferred i3 ∪ i1) ≡ d
    @test Interval{:open,:closed}(i1) ∪ Interval{:open,:closed}(i3) ≡
            Interval{:open,:closed}(i3) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(d)
    @test Interval{:closed,:open}(i1) ∪ Interval{:closed,:open}(i3) ≡
            Interval{:closed,:open}(i3) ∪ Interval{:closed,:open}(i1) ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i1) ∪ OpenInterval(i3) ≡
            OpenInterval(i3) ∪ OpenInterval(i1) ≡ OpenInterval(d)
    @test i1 ∪ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∪ i1 ≡ d
    @test i1 ∪ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∪ i1 ≡ Interval{:closed,:open}(d)
    @test i1 ∪ OpenInterval(i3) ≡ OpenInterval(i3) ∪ i1 ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i1) ∪ i3 ≡ i3 ∪ OpenInterval(i1) ≡ Interval{:open,:closed}(d)
    @test OpenInterval(i1) ∪ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∪ OpenInterval(i1) ≡ Interval{:open,:closed}(d)
    @test OpenInterval(i1) ∪ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∪ OpenInterval(i1) ≡ OpenInterval(d)
    @test Interval{:open,:closed}(i1) ∪ OpenInterval(i3) ≡ OpenInterval(i3) ∪ Interval{:open,:closed}(i1) ≡ OpenInterval(d)
    @test Interval{:open,:closed}(i1) ∪ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∪ Interval{:open,:closed}(i1) ≡ OpenInterval(d)

    # - intersection of partially overlapping intervals
    # i1      0 ------>------ 1
    # i3                 1/2 ------>------ 2
    d = one(T)/2 .. one(T)
    @test (@inferred i1 ∩ i3) ≡ (@inferred i3 ∩ i1) ≡ d
    @test Interval{:open,:closed}(i1) ∩ Interval{:open,:closed}(i3) ≡
            Interval{:open,:closed}(i3) ∩ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(d)
    @test Interval{:closed,:open}(i1) ∩ Interval{:closed,:open}(i3) ≡
            Interval{:closed,:open}(i3) ∩ Interval{:closed,:open}(i1) ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i1) ∩ OpenInterval(i3) ≡
            OpenInterval(i3) ∩ OpenInterval(i1) ≡ OpenInterval(d)
    @test i1 ∩ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∩ i1 ≡ Interval{:open,:closed}(d)
    @test i1 ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ i1 ≡ d
    @test i1 ∩ OpenInterval(i3) ≡ OpenInterval(i3) ∩ i1 ≡ Interval{:open,:closed}(d)
    @test OpenInterval(i1) ∩ i3 ≡ i3 ∩ OpenInterval(i1) ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i1) ∩ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∩ OpenInterval(i1) ≡ OpenInterval(d)
    @test OpenInterval(i1) ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ OpenInterval(i1) ≡ Interval{:closed,:open}(d)
    @test Interval{:open,:closed}(i1) ∩ OpenInterval(i3) ≡ OpenInterval(i3) ∩ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(d)
    @test Interval{:open,:closed}(i1) ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ Interval{:open,:closed}(i1) ≡ d
    @test !isdisjoint(i1, i3)


    # - union of barely overlapping intervals
    # i2         1/3 ->- 1/2
    # i3                 1/2 ------>------ 2
    d = one(T)/3 .. 2*one(T)
    @test (@inferred i2 ∪ i3) ≡ (@inferred i3 ∪ i2) ≡ d
    @test Interval{:open,:closed}(i2) ∪ Interval{:open,:closed}(i3) ≡
            Interval{:open,:closed}(i3) ∪ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(d)
    @test Interval{:closed,:open}(i2) ∪ Interval{:closed,:open}(i3) ≡
            Interval{:closed,:open}(i3) ∪ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(d)
    @test_throws ArgumentError OpenInterval(i2) ∪ OpenInterval(i3)
    @test i2 ∪ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∪ i2 ≡ d
    @test i2 ∪ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∪ i2 ≡ Interval{:closed,:open}(d)
    @test i2 ∪ OpenInterval(i3) ≡ OpenInterval(i3) ∪ i2 ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i2) ∪ i3 ≡ i3 ∪ OpenInterval(i2) ≡ Interval{:open,:closed}(d)
    @test_throws ArgumentError OpenInterval(i2) ∪ Interval{:open,:closed}(i3)
    @test Interval{:open,:closed}(i2) ∪ OpenInterval(i3) ≡ OpenInterval(i3) ∪ Interval{:open,:closed}(i2) ≡ OpenInterval(d)
    @test Interval{:open,:closed}(i2) ∪ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∪ Interval{:open,:closed}(i2) ≡ OpenInterval(d)

    # - intersection of barely overlapping intervals
    # i2         1/3 ->- 1/2
    # i3                 1/2 ------>------ 2
    d = one(T)/2 .. one(T)/2
    @test (@inferred i2 ∩ i3) ≡ (@inferred i3 ∩ i2) ≡ d
    @test Interval{:open,:closed}(i2) ∩ Interval{:open,:closed}(i3) ≡
            Interval{:open,:closed}(i3) ∩ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(d)
    @test Interval{:closed,:open}(i2) ∩ Interval{:closed,:open}(i3) ≡
            Interval{:closed,:open}(i3) ∩ Interval{:closed,:open}(i2) ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i2) ∩ OpenInterval(i3) ≡
            OpenInterval(i3) ∩ OpenInterval(i2) ≡ OpenInterval(d)
    @test i2 ∩ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∩ i2 ≡ Interval{:open,:closed}(d)
    @test i2 ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ i2 ≡ d
    @test i2 ∩ OpenInterval(i3) ≡ OpenInterval(i3) ∩ i2 ≡ Interval{:open,:closed}(d)
    @test OpenInterval(i2) ∩ i3 ≡ i3 ∩ OpenInterval(i2) ≡ Interval{:closed,:open}(d)
    @test OpenInterval(i2) ∩ Interval{:open,:closed}(i3) ≡ Interval{:open,:closed}(i3) ∩ OpenInterval(i2) ≡ OpenInterval(d)
    @test OpenInterval(i2) ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ OpenInterval(i2) ≡ Interval{:closed,:open}(d)
    @test Interval{:open,:closed}(i2) ∩ OpenInterval(i3) ≡ OpenInterval(i3) ∩ Interval{:open,:closed}(i2) ≡ Interval{:open,:closed}(d)
    @test Interval{:open,:closed}(i2) ∩ Interval{:closed,:open}(i3) ≡ Interval{:closed,:open}(i3) ∩ Interval{:open,:closed}(i2) ≡ d

    # - intersection of custom intervals
    @test intersect(MyUnitInterval(true,true), MyUnitInterval(false,false)) == OpenInterval(0,1)
    @test intersect(MyUnitInterval(true,true), OpenInterval(0,1)) == OpenInterval(0,1)

    # - union of non-overlapping intervals
    # i1      0 ------>------ 1
    # i4                                   2 -->-- 3
    @test_throws ArgumentError i1 ∪ i4
    @test_throws ArgumentError i4 ∪ i1
    @test_throws ArgumentError OpenInterval(i1) ∪ i4
    @test_throws ArgumentError i1 ∪ OpenInterval(i4)
    @test_throws ArgumentError Interval{:closed,:open}(i1) ∪ i4
    @test_throws ArgumentError Interval{:closed,:open}(i1) ∪ OpenInterval(i4)

    # - union of almost-overlapping intervals
    # i1      0 ------>------ 1
    # i5                        1.0+ -->-- 2
    @test_throws ArgumentError i1 ∪ i5
    @test_throws ArgumentError i5 ∪ i1
    @test_throws ArgumentError OpenInterval(i1) ∪ i5
    @test_throws ArgumentError i1 ∪ OpenInterval(i5)
    @test_throws ArgumentError Interval{:closed,:open}(i1) ∪ i5
    @test_throws ArgumentError Interval{:closed,:open}(i1) ∪ OpenInterval(i5)

    # - intersection of non-overlapping intervals
    # i1      0 ------>------ 1
    # i4                                   2 -->-- 3
    @test isempty(i1 ∩ i4)
    @test isempty(i4 ∩ i1)
    @test isempty(OpenInterval(i1) ∩ i4)
    @test isempty(i1 ∩ OpenInterval(i4))
    @test isempty(Interval{:closed,:open}(i1) ∩ i4)
    @test isdisjoint(i1, i4)
    @test isdisjoint(i4, i1)
    @test isdisjoint(OpenInterval(i1), i4)
    @test isdisjoint(i1, OpenInterval(i4))
    @test isdisjoint(Interval{:closed,:open}(i1), i4)


    # - intersection of almost-overlapping intervals
    # i1      0 ------>------ 1
    # i5                        1.0+ -->-- 2
    @test isempty(i1 ∩ i5)
    @test isempty(i5 ∩ i1)
    @test isempty(OpenInterval(i1) ∩ i5)
    @test isempty(i1 ∩ OpenInterval(i5))
    @test isempty(Interval{:closed,:open}(i1) ∩ i5)
    @test isdisjoint(i1, i5)
    @test isdisjoint(i5, i1)
    @test isdisjoint(OpenInterval(i1), i5)
    @test isdisjoint(i1, OpenInterval(i5))
    @test isdisjoint(Interval{:closed,:open}(i1), i5)

    # - union of interval with empty
    # i1      0 ------>------ 1
    # i_empty 0 ------<------ 1
    @test i1 ∪ i_empty ≡ i_empty ∪ i1 ≡ i1
    @test Interval{:open,:closed}(i1) ∪ Interval{:open,:closed}(i_empty) ≡
            Interval{:open,:closed}(i_empty) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)
    @test Interval{:closed,:open}(i1) ∪ Interval{:closed,:open}(i_empty) ≡
            Interval{:closed,:open}(i_empty) ∪ Interval{:closed,:open}(i1) ≡ Interval{:closed,:open}(i1)
    @test OpenInterval(i1) ∪ OpenInterval(i_empty) ≡
            OpenInterval(i_empty) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test i1 ∪ Interval{:open,:closed}(i_empty) ≡ Interval{:open,:closed}(i_empty) ∪ i1 ≡ i1
    @test i1 ∪ Interval{:closed,:open}(i_empty) ≡ Interval{:closed,:open}(i_empty) ∪ i1 ≡ i1
    @test i1 ∪ OpenInterval(i_empty) ≡ OpenInterval(i_empty) ∪ i1 ≡ i1
    @test OpenInterval(i1) ∪ i_empty ≡ i_empty ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test OpenInterval(i1) ∪ Interval{:open,:closed}(i_empty) ≡ Interval{:open,:closed}(i_empty) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test OpenInterval(i1) ∪ Interval{:closed,:open}(i_empty) ≡ Interval{:closed,:open}(i_empty) ∪ OpenInterval(i1) ≡ OpenInterval(i1)
    @test Interval{:open,:closed}(i1) ∪ OpenInterval(i_empty) ≡ OpenInterval(i_empty) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)
    @test Interval{:open,:closed}(i1) ∪ Interval{:closed,:open}(i_empty) ≡ Interval{:closed,:open}(i_empty) ∪ Interval{:open,:closed}(i1) ≡ Interval{:open,:closed}(i1)

    # - intersection of interval with empty
    # i1      0 ------>------ 1
    # i_empty 0 ------<------ 1
    @test isempty(i1 ∩ i_empty)
    @test isempty(i_empty ∩ i1)
    @test isempty(OpenInterval(i1) ∩ i_empty)
    @test isempty(i1 ∩ OpenInterval(i_empty))
    @test isempty(Interval{:closed,:open}(i1) ∩ i_empty)
    @test isdisjoint(i1, i_empty)
    @test isdisjoint(i_empty, i1)
    @test isdisjoint(OpenInterval(i1), i_empty)
    @test isdisjoint(i1, OpenInterval(i_empty))
    @test isdisjoint(Interval{:closed,:open}(i1), i_empty)

    # - test matching endpoints
    @test (0..1) ∪ OpenInterval(0..1) ≡ OpenInterval(0..1) ∪ (0..1) ≡  0..1
    @test Interval{:open,:closed}(0..1) ∪ OpenInterval(0..1) ≡
            OpenInterval(0..1) ∪ Interval{:open,:closed}(0..1) ≡
            Interval{:open,:closed}(0..1)
    @test Interval{:closed,:open}(0..1) ∪ OpenInterval(0..1) ≡
            OpenInterval(0..1) ∪ Interval{:closed,:open}(0..1) ≡
            Interval{:closed,:open}(0..1)

    # - different interval types
    @test (1..2) ∩ OpenInterval(0.5, 1.5) ≡ Interval{:closed, :open}(1, 1.5)
    @test (1..2) ∪ OpenInterval(0.5, 1.5) ≡ Interval{:open, :closed}(0.5, 2)
end

@testset "in" begin
    @test in(0.1, 0.0..1.0) == true
    @test in(0.0, 0.0..1.0) == true
    @test in(1.1, 0.0..1.0) == false
    @test in(0.0, nextfloat(0.0)..1.0) == false

    @testset "missing in" begin
        @test ismissing(missing in 0..1)
        @test !(missing in 1..0)
        @test ismissing(missing in OpenInterval(0, 1))
        @test ismissing(missing in Interval{:closed, :open}(0, 1))
        @test ismissing(missing in Interval{:open, :closed}(0, 1))
    end

    @testset "complex in" begin
        @test 0+im ∉ 0..2
        @test 0+0im ∈ 0..2
        @test 0+eps()im ∉ 0..2

        @test 0+im ∉ OpenInterval(0,2)
        @test 0+0im ∉ OpenInterval(0,2)
        @test 1+0im ∈ OpenInterval(0,2)
        @test 1+eps()im ∉ OpenInterval(0,2)

        @test 0+im ∉ Interval{:closed,:open}(0,2)
        @test 0+0im ∈ Interval{:closed,:open}(0,2)
        @test 1+0im ∈ Interval{:closed,:open}(0,2)
        @test 1+eps()im ∉ Interval{:closed,:open}(0,2)

        @test 0+im ∉ Interval{:open,:closed}(0,2)
        @test 0+0im ∉ Interval{:open,:closed}(0,2)
        @test 1+0im ∈ Interval{:open,:closed}(0,2)
        @test 1+eps()im ∉ Interval{:open,:closed}(0,2)
    end
end

@testset "issubset" begin
    I = 0..3
    J = 1..2
    @test J ⊆ I
    @test I ⊈ J
    @test OpenInterval(J) ⊆ I
    @test OpenInterval(I) ⊈ J
    @test J ⊆ OpenInterval(I)
    @test I ⊈ OpenInterval(J)
    @test OpenInterval(J) ⊆ OpenInterval(I)
    @test OpenInterval(I) ⊈ OpenInterval(J)
    @test Interval{:closed,:open}(J) ⊆ OpenInterval(I)
    @test Interval{:open,:closed}(J) ⊆ OpenInterval(I)
    @test Interval{:open,:closed}(J) ⊆ Interval{:open,:closed}(I)
    @test OpenInterval(I) ⊈ OpenInterval(J)

    @test Interval{:closed,:open}(J) ⊆ I
    @test I ⊈ Interval{:closed,:open}(J)

    @test I ⊆ I
    @test OpenInterval(I) ⊆ I
    @test Interval{:open,:closed}(I) ⊆ I
    @test Interval{:closed,:open}(I) ⊆ I
    @test I ⊈ OpenInterval(I)
    @test I ⊈ Interval{:open,:closed}(I)
    @test I ⊈ Interval{:closed,:open}(I)

    @test Interval{:closed,:open}(I) ⊆ Interval{:closed,:open}(I)
    @test Interval{:open,:closed}(I) ⊈ Interval{:closed,:open}(I)

    @test !isequal(I, OpenInterval(I))
    @test !(I == OpenInterval(I))

    @test issubset(Interval{:closed,:closed}(1,2), Interval{:closed,:closed}(1,2)) == true
    @test issubset(Interval{:closed,:closed}(1,2), Interval{:open  ,:open  }(1,2)) == false
    @test issubset(Interval{:closed,:open  }(1,2), Interval{:open  ,:open  }(1,2)) == false
    @test issubset(Interval{:open  ,:closed}(1,2), Interval{:open  ,:open  }(1,2)) == false
    @test issubset(Interval{:closed,:closed}(1,2), Interval{:closed,:closed}(1,prevfloat(2.0))) == false
    @test issubset(Interval{:closed,:open  }(1,2), Interval{:open  ,:open  }(prevfloat(1.0),2)) == true
end

@testset "empty intervals" begin
    for T in (Float32,Float64)
        @test isempty(Interval{:open,:open}(zero(T),zero(T)))
        @test zero(T) ∉ Interval{:open,:open}(zero(T),zero(T))
        @test isempty(Interval{:open,:closed}(zero(T),zero(T)))
        @test zero(T) ∉ Interval{:open,:closed}(zero(T),zero(T))
        @test isempty(Interval{:closed,:open}(zero(T),zero(T)))
        @test zero(T) ∉ Interval{:closed,:open}(zero(T),zero(T))
    end
end

using IntervalSets
using Documenter

# We need to set `ENV["GKSwstype"]` to suppress the warning on GitHub Actions.
# https://github.com/JuliaPlots/Plots.jl/issues/1076#issuecomment-327509819
ENV["GKSwstype"] = "100"

DocMeta.setdocmeta!(IntervalSets, :DocTestSetup, :(using IntervalSets); recursive=true)

makedocs(;
    modules=[IntervalSets],
    repo="https://github.com/JuliaMath/IntervalSets.jl/blob/{commit}{path}#{line}",
    sitename="IntervalSets.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://JuliaMath.github.io/IntervalSets.jl",
        assets = ["assets/custom.css", "assets/favicon.ico"],
        repolink="https://github.com/JuliaMath/IntervalSets.jl",
    ),
    pages=[
        "Home" => "index.md",
        "APIs" => "api.md",
    ],
)

deploydocs(;
    repo="github.com/JuliaMath/IntervalSets.jl", devbranch="master",
)

# IntervalSets.jl

A Julia package implementing [interval sets](https://en.wikipedia.org/wiki/Interval_(mathematics)).

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/IntervalSets.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaMath.github.io/IntervalSets.jl/dev)
[![Build Status](https://github.com/JuliaMath/IntervalSets.jl/workflows/CI/badge.svg)](https://github.com/JuliaMath/IntervalSets.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaMath/IntervalSets.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaMath/IntervalSets.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

!!! note "Documentation"
    The documentation is still work in progress.
    For more information, see also
    * [README in the repository](https://github.com/JuliaMath/IntervalSets.jl)
    * [Tests in the repository](https://github.com/JuliaMath/IntervalSets.jl/tree/master/test)
    Feel free to [open pull requests](https://github.com/JuliaMath/IntervalSets.jl/pulls) and improve this document!

## Installation
```
pkg> add IntervalSets
```

## Quick start

```@repl
using IntervalSets
i1 = 1.0 .. 3.0
i2 = OpenInterval(0..4)
i1 ⊆ i2
i2 ⊆ i1
```

Currently this package defines one concrete type, [`Interval`](@ref).
These define the set spanning from `a` to `b`, meaning the interval is defined as the set ``\{x \ | \ a ≤ x ≤ b\}``.
This is sometimes written ``[a,b]`` (mathematics syntax, not Julia syntax) or ``a..b``.

Optionally, `Interval{L,R}` can represent open and half-open intervals.
The type parameters `L` and `R` correspond to the left and right endpoint respectively.
The notation [`ClosedInterval`](@ref) is short for `Interval{:closed,:closed}`,
while [`OpenInterval`](@ref) is short for `Interval{:open,:open}`.
For example, the interval `Interval{:open,:closed}` corresponds to the set ``(a,b] = \{x \ | \ a < x ≤ b\}``.

## More examples

```@setup more
using IntervalSets
```

### Constructors
```@repl more
ClosedInterval{Float64}(1,3)
OpenInterval{Float64}(1,3)
Interval{:open, :closed}(1,3)
OpenInterval(0.5..2.5)  # construct `OpenInterval` from `ClosedInterval`
```

The [`±`](@ref) operator and [`..`](@ref) creates [`ClosedInterval`](@ref) instance.

```@repl more
0.5..2.5
1.5 ± 1  # \pm<TAB>
```

There is also a useful string macro [`@iv_str`](@ref) to define an interval with mathematical notations such as ``(a,b]``.

```@repl more
iv"[1,2]"
iv"[1,2)"
iv"(1,2]"
iv"(1,2)"
```

### Set operations

```@repl more
1.75 ∈ 1.5±1  # \in<TAB>; can also use `in`
0 ∈ 1.5±1
1 ∈ OpenInterval(0..1)
intersect(1..5, 3..7)   # can also use `a ∩ b`, where the symbol is \cap<TAB>
isempty(intersect(1..5, 10..11))
(0.25..5) ∪ (3..7.4)  # \cup<TAB>; can also use `union()`
isclosedset(0.5..2.0)
isopenset(OpenInterval(0.5..2.5))
isleftopen(2..3)
(0.25..5) ∪ (6..7.4)  # union of interval must be an interval
```

### Visualization
`Interval`s can be visulalized with `Plots.plot` function.

```@example plot
using IntervalSets, Plots
plot(iv"(1,2)")
plot!(iv"[3,6)")
plot!(iv"[5,7)")
savefig("plot-intervals.png") # hide
nothing # hide
```

![](plot-intervals.png)

The `offset` keyword argument is useful for avoid duplication.

```@example plot
plot(iv"[1,3]")
plot!(iv"(2,4)"; offset=-0.1, ylims=(-1,1))
savefig("plot-intervals-offset.png") # hide
nothing # hide
```

![](plot-intervals-offset.png)

### Importing the `..` operator

To import the [`..`](@ref) operator, use `import IntervalSets: (..)`.
The parantheses are necessary to avoid parsing issues.

```@repl
import IntervalSets: (..)
import IntervalSets.(..)  # This is also okay
```
